
/*********************************************************************

	32bitOps.c

	Operators for the  32bit Binarystringsystem
	-------------------------------------------



		(c) Wed Jan 18 16:00:30 MET 1995   PeD

***********************************************************************/




/**********************************************************
	abstract 4-bit machine
 **********************************************************/


#include <string.h>

#include "autoReac.h"
#include "ARIntern.h"

#define VERSION 1.0

#define ON 1			/* def. for copy mode */
#define OFF 0

#define LEFT 64			/* def. for direction */
#define RIGHT 4711

#define BOTH 0			/* def. for movMode (must start with 0)*/
#define OPERAND_PT 1
#define RESULT_PT 2
#define MAX_MOV_MODE RESULT_PT 

#define ARITHMOV mMov()		/* this op. is performed after each 
				arithmetic operation, if movAfterArith is 
				set to ON */


#define GET_NEXT_INST_DEFAULT 0 /* returned value of getNextInstruction() if prgReg is empty 
					(also remainingNibbels <= 0) */

#define NOT_FOUND 0xf0000000   /* used & returned by decodeToken */

#define DEFAULT_CODE 0xd  /* used by the ass. to fillup the remaining nibbles
				if the sourcecode contains less than 8 inst. */

#define RESULT_INIT resultDefault

/* __________ the instruction-table ____________________________________________ */

#ifndef NEVER

InstructionTable instructionTable =		/* defines from 32bitOpsIntern.h */
{		
		ID,	/* 0000   0	*/
		MOV,	/* 0001   1	*/ 
		SETP,	/* 0010		*/
		TMM,	/* 0011		*/
		TDIR,	/* 0100	  4	*/	
		UNSETP,	/* 0101		*/
		CPON,	/* 0110		*/
		CPOFF,	/* 0111		*/
		STOP,	/* 1000	  8	*/
		OR,	/* 1001	  9	*/
		NOT,	/* 1010	  a	*/
		EXOR,	/* 1011	  b	*/
		EXOR,	/* 1100	 12	*/
		NOP,	/* 1101		*/
		ID,	/* 1110		*/
		AND	/* 1111	 15	*/
};



InstructionTable  instructionTable01 = 
{		

		ID,	/* 0000   0	*/
		MOV,	/* 0001   1	*/ 
		SETP,	/* 0010		*/
		TMM,	/* 0011		*/
		TDIR,	/* 0100	  4	*/	
		UNSETP,	/* 0101		*/
		CPON,	/* 0110		*/
		CPOFF,	/* 0111		*/
		STOP,	/* 1000	  8	*/
		OR,	/* 1001	  9	*/
		NOT,	/* 1010	  a	*/
		EXOR,	/* 1011	  b	*/
		EXOR,	/* 1100	 12	*/
		NOP,	/* 1101		*/
		ID,	/* 1110		*/
		AND	/* 1111	 15	*/
};

InstructionTable  instructionTable02 = 
{
		ID,	/* 0000   0	*/
		MOV,	/* 0001   1	*/ 
		SETP,	/* 0010		*/
		TMM,	/* 0011		*/
		TDIR,	/* 0100	  4	*/	
		UNSETP,	/* 0101		*/
		CPON,	/* 0110		*/
		CPOFF,	/* 0111		*/
		STOP,	/* 1000	  8	*/
		OR,	/* 1001	  9	*/
		EQ,	/* 1010	  a	*/
		EXOR,	/* 1011	  b	*/
		EXOR,	/* 1100	 12	*/
		NOP,	/* 1101		*/
		ID,	/* 1110		*/
		AND	/* 1111	 15	*/
};

InstructionTable  instructionTable03 = 
{
		ID,	/* 0000   0	*/
		MOV,	/* 0001   1	*/ 
		SETP,	/* 0010		*/
		TMM,	/* 0011		*/
		TDIR,	/* 0100	  4	*/	
		UNSETP,	/* 0101		*/
		CPON,	/* 0110		*/
		CPOFF,	/* 0111		*/
		STOP,	/* 1000	  8	*/
		OR,	/* 1001	  9	*/
		ID,	/* 1010	  a	*/
		EXOR,	/* 1011	  b	*/
		EXOR,	/* 1100	 12	*/
		NOP,	/* 1101		*/
		ID,	/* 1110		*/
		AND	/* 1111	 15	*/
};

InstructionTable  instructionTable04 = 
{
		ID,	/* 0000   0	*/
		MOV,	/* 0001   1	*/ 
		SETP,	/* 0010		*/
		TMM,	/* 0011		*/
		TDIR,	/* 0100	  4	*/	
		UNSETP,	/* 0101		*/
		CPON,	/* 0110		*/
		CPOFF,	/* 0111		*/
		STOP,	/* 1000	  8	*/
		OR,	/* 1001	  9	*/
		NOT,	/* 1010	  a	*/
		EXOR,	/* 1011	  b	*/
		EXOR,	/* 1100	 12	*/
		NOP,	/* 1101		*/
		ID,	/* 1110		*/
		AND	/* 1111	 15	*/
};

#endif

/* ________________ intern proc. decl. ______________________________ */

void			callMicroCode(unsigned long int aktInstruction);
unsigned long int	getNextInstruction();
FILE			*adocFH = (FILE*)NULL;


/* ____________ global state var. for the machine ____________________ */

unsigned long int	opReg, resultReg ;	/* Register for operand and result    */
unsigned long int	patternReg ;		/* Register to store a n-Bit pattern  */
unsigned long int	patternMask ;		/* 3: 2-Bit Pattern, 15: 4-Bit Pattern */
unsigned long int	acc ;			/* help register */

unsigned long int	resultDefault;

unsigned long int	prgReg;			/* contains the programm (init. by mLoadPrgReg(prg)))*/
int			remainingPrgNibbles;	/* in the prgReg. e.g. 0: no Programm 8: after init 
						is set by mInit and decremented by getNextInstruction */

int			resultPtPos;

int			patternSet;		/* Flag: 1 pattern has been set */

int			stopFlag;		/* 1/0   1: machine stoped */
int			copyMode;		/* ON/OFF */
MicroCode		copyFunction;		/* called before MOVPT instruction, if
						   copyMode == ON */
int			setCpyFunByArithOp;	/* ON: copyFunction is set by each logic or arith. Operation */


int			direction;		/* LEFT/RIGHT */
int			movMode;		/* BOTH/OPERAND_PT/RESULT_PT */

int			movAfterArith;		/* ON/OFF 
						ON: ARITHMOV oper. performed after each bool. operation like EXOR */


int			debugOn;		/* Flag: 1 debug mode on */
int			noCorrectionI = 0 ;

int			myBindingPref = 0; 




/* ___________ interfacing ___________________________ */

/****************************
 * reactionA1               *
 ****************************/


S32 reactionA1(S32 Operator, S32 operand)
{
/*      setResultDefault(soup[RANDOM % maxPop]); (useless at the moment !!!) */
        return (S32)runN((unsigned long int) Operator, (unsigned long int) operand, 
                             1 /* a1Rate */);
}

void	reactionInitA1()
{
	setInstructionTable(1);
}


/****************************
 * reactionA2               *
 ****************************/


S32 reactionA2(S32 Operator, S32 operand)
{
        return (S32)runN((unsigned long int) Operator, (unsigned long int) operand, 
                             1 /* a1Rate */);
}

void	reactionInitA2()
{
	setInstructionTable(2);
}



/* _______________ implemntation ______________________________________- */







void setBindingPref(int bp)
{
	myBindingPref = bp;
}

void setNoCorrection()
{
	if (adocFH != (FILE *)NULL)
		fprintf(adocFH, "\n32bitOps: correction disabled !\n");
	printf("\n32bitOps: correction disabled\n" );
	noCorrectionI = 1;
}


void setInstructionTable(int no)
{
	int i;
	if (adocFH != (FILE *)NULL)
		fprintf(adocFH, "instructionTable changed to %d\n", no);
	printf("instructionTable changed to %d\n", no);

	
	for(i=0; i<16;i++)
	{
		switch(no)
		{
			case 1:
				instructionTable[i] = instructionTable01[i];
				break;
			case 2:
				instructionTable[i] = instructionTable02[i];
				break;
			case 3:
				instructionTable[i] = instructionTable03[i];
				break;
			case 4:
				instructionTable[i] = instructionTable04[i];
				break;
			default:
				fprintf(stderr, "ERROR: unkown instructionTable : %d\n", no);
				exit(1);
		}
	}
}


/****************************
 * opsAutoDoc               *
 ****************************/


void	opsAutoDoc(FILE *fh)
{
	adocFH = fh;
        fprintf(fh, "\n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
        fprintf(fh, "  32bitOps-module automatic documentation     Version : %02.2f \n", VERSION);
        fprintf(fh, "- - - - - -- - - - - - - - - - - - - - - - - - - - - - - - - - - - \n");
        fprintf(fh, "   compiled :   date   %s       time   %s\n", __DATE__, __TIME__);
        fprintf(fh, "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");

	fprintAss(fh);
        fprintf(fh, "\n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");
}



/* ---------------------------------------------------------------------------------------------- */

void                    setResultDefault(unsigned long resultDef)
{
	resultDefault = resultDef;
}

/****************************
 *  mInit(operand)          *
 ****************************/

void	mInit(unsigned long int operand)
{

	resultReg		= RESULT_INIT;
	opReg			= operand;

	patternSet	= OFF;		 
	patternReg	= 0x00000000;
	patternMask	= 0x00000003;	/* default: 2 bit pattern */
	direction	= LEFT; 

	resultPtPos	= 0;

	copyMode	= OFF;
	movMode		= BOTH;
	movAfterArith	= ON;	

	copyFunction	= mId ;
	setCpyFunByArithOp = ON ;	/* the copy fun. is set by each
					  arith. or logic function */
	stopFlag	= 0;
}



/****************************
 * mExor                    *
 ****************************/

void	mExor()
{
	acc = opReg & 0x00000001;	/* mask bit 0 */
	resultReg = resultReg ^ acc;	/* and exor it with result reg. */
}

/****************************
 * mAnd                     *
 ****************************/

void	mAnd()
{
	acc = opReg | 0xfffffffe;	/* mask bit 0 */
	resultReg = resultReg & acc;	/* and and it with result reg. */
}

/****************************
 * mOr                      *
 ****************************/

void	mOr()
{
	acc = opReg & 0x00000001;	/* mask bit 0 */
	resultReg = resultReg | acc;	/* and or it with result reg. */

}

/****************************
 * mNot                     *
 ****************************/
 /* r0 := NOT op0 */

void	mNot()
{
	acc = opReg ^ 0x00000001;		/* invert bit 0 of opReg -> acc*/

	acc = acc & 0x00000001;			/* set bit 0 of resultReg to bit 0 of acc */
	resultReg = (resultReg & 0xfffffffe)| acc;	
}


/****************************
 * mId                      *
 ****************************/
 /* r0 :=  op0 */

void	mId()
{
	acc = opReg & 0x000000001;			/* set bit 0 of resultReg to bit 0 of acc */
	resultReg = (resultReg & 0xfffffffe)| acc;	
}

/****************************
 * mEq                      *
 ****************************/
 /* r0 :=  (op0 = r0) */

void	mEq()
{
	resultReg = resultReg ^ 0x00000001;	/* invert bit 0 of resultReg */
	mExor();				/* call mExor */
}

/* ____________ one step move operations ______________________________________________ */

/****************************
 * mMovOpPtLeft()           *
 ****************************/

void    mMovOpPtLeft()
{
	unsigned long int	tmp;

	tmp = opReg & 0x00000001 ;	/* save bit 0 */
	opReg >>= 1;			/* shift right (same as moving the pointer left) */
	opReg |= (tmp << 31);		/* mov bit in tmp to position 31 and or it to opReg */
}


/****************************
 * mMovOpPtRight()          *
 ****************************/

void    mMovOpPtRight()
{
	unsigned long int	tmp;

	tmp = opReg & 0x80000000 ;	/* save bit 31 */
	opReg <<= 1;			/* shift left */
	opReg |= (tmp >> 31);		/* mov bit in tmp to position 0 and or it to opReg */

}


/****************************
 * mMovResPtLeft()           *
 ****************************/

void    mMovResPtLeft()
{
	unsigned long int	tmp;

	tmp = resultReg & 0x00000001 ;	/* save bit 0 */
	resultReg >>= 1;		/* shift right (same as moving the pointer left) */
	resultReg |= (tmp << 31);	/* mov bit in tmp to position 31 and or it to resultReg */
	resultPtPos++;
}


/****************************
 * mMovResPtRight()          *
 ****************************/

void    mMovResPtRight()
{
	unsigned long int	tmp;

	tmp = resultReg & 0x80000000 ;	/* save bit 31 */
	resultReg <<= 1;		/* shift left */
	resultReg |= (tmp >> 31);	/* mov bit in tmp to position 0 and or it to resultReg */
	resultPtPos--;
}

/****************************
 * mMovPtLeft()             *   (both pointer)
 ****************************/

void    mMovPtLeft()
{
	mMovOpPtLeft();
	mMovResPtLeft();
}

/****************************
 * mMovPtRight()             *   (both pointer)
 ****************************/

void    mMovPtRight()
{
	mMovOpPtRight();
	mMovResPtRight();
}

/* ______________________ pattern micro code ____________________________________ */

/****************************
 * mSetPattern              *
 ****************************/

void mSetPattern(unsigned long int arg)
{
	patternReg = arg;
	patternMask = 0xf;	/* 4bit pattern */
	patternSet = ON;
}

/****************************
 * mSetPattern00()          *
 ****************************/

void    mSetPattern00()
{
	patternSet = ON;
	patternReg = 0; /*  00  */
	patternMask = 0x3 ;  /* 2bit pattern */
}


/****************************
 * mSetPattern01()          *
 ****************************/

void    mSetPattern01()
{
	patternSet = ON;
	patternReg = 1; /*  01  */
	patternMask = 0x3 ;  /* 2bit pattern */
}

/****************************
 * mSetPattern10()          *
 ****************************/

void    mSetPattern10()
{
	patternSet = ON;
	patternReg = 2; /*  10  */
	patternMask = 0x3 ;  /* 2bit pattern */
}

/****************************
 * mSetPattern11()          *
 ****************************/

void    mSetPattern11()
{
	patternSet = ON;
	patternReg = 3; /*  11  */
	patternMask = 0x3 ;  /* 2bit pattern */
}

/****************************
 * mUnSetPattern()          *
 ****************************/

void    mUnSetPattern()
{
	patternSet = OFF;
	patternReg = 0; /*  obsolet, patternSet=0 is sufficient  */
}

/****************************
 * mMovToPatternLeft       *
 ****************************/

void    mMovToPatternLeft()
{
	int i;

	if (! patternSet)		/* pattern not set => move both pt. one step left */
		mMovPtLeft();
	else
		for (i=0; i < STRING_LENGTH; i++)
		{
			mMovPtLeft();					/* move both Pt left */
			if (patternReg == (opReg & 0x00000003))
				i = 1000;	/* break */
		}
}

/****************************
 * mMovToPatternRight      *
 ****************************/

void    mMovToPatternRight()
{
	int i;
	if (! patternSet)
		mMovPtRight();
	else
		for (i=0; i < STRING_LENGTH; i++)
		{
			mMovPtRight();					/* move both Pt left */
			if (patternReg == (opReg & 0x00000003))
				i = 1000;	/* break */
		}
}

/****************************
 * mShiftToPatternLeft       *
 ****************************/

void    mShiftToPatternLeft()
{
	int i;

	if (! patternSet)		/* pattern not set => move both pt. one step left */
		mMovOpPtLeft();
	else
		for (i=0; i < STRING_LENGTH; i++)
		{
			mMovOpPtLeft();					/* move both Pt left */
			if (patternReg == (opReg & 0x00000003))
				i = 1000;	/* break */
		}
}

/****************************
 * mShiftToPatternRight      *
 ****************************/

/* move onley teh operand pointer */

void    mShiftToPatternRight()
{
	int i;
	if (! patternSet)
		mMovOpPtRight();
	else
		for (i=0; i < STRING_LENGTH; i++)
		{
			mMovOpPtRight();				/* move both Pt left */
			if (patternReg == (opReg & 0x00000003))
				i = 1000;	/* break */
		}
}

/****************************
 * mMov                     *
 ****************************/
void mMov()
{
	int i;
	if (! patternSet)
		mMovOneStep();
	else
		for (i=0; i < STRING_LENGTH; i++)
		{
			mMovOneStep();	
			if (movMode == RESULT_PT)
			{
				if (patternReg == (resultReg & patternMask))
					i = 1000;	/* break */
			}
			else    if (patternReg == (opReg     & patternMask))
					i = 1000;	/* break */
		}
}

/****************************
 * mMovOneStep              *
 ****************************/

void mMovOneStep()
{ 
	if (copyMode)
		copyFunction();

	if (direction == LEFT)
	{
		switch(movMode)
		{
			case(BOTH):
				mMovResPtLeft();
				mMovOpPtLeft();
				break;
			case(OPERAND_PT):
				mMovOpPtLeft();
				break;
			case(RESULT_PT):
				mMovResPtLeft();
				break;
			default:
				fprintf(stderr, "ERROR(mMov): invalid movMode : %d\n", movMode);
		}
	} 
	else if (direction == RIGHT)
	{
		switch(movMode)
		{
			case(BOTH):
				mMovResPtRight();
				mMovOpPtRight();
				break;
			case(OPERAND_PT):
				mMovOpPtRight();
				break;
			case(RESULT_PT):
				mMovResPtRight();
				break;
			default:
				fprintf(stderr, "ERROR(mMov): invalid movMode : %d\n", movMode);
		}
	} 	
	else
		fprintf(stderr, "ERROR(mMov): invalid direction : %d\n", direction);
}

/****************************
 * mToggleMovMode           *
 ****************************/

void mToggleMovMode()
{
	movMode++;
	if (movMode > MAX_MOV_MODE)
		movMode = 0;
}

/****************************
 * mToggleDir               *
 ****************************/
void mToggleDir()
{
	if (direction == LEFT)
		direction = RIGHT;
	else
		direction = LEFT;
}

/****************************
 * mCopyOn                   *
 ****************************/

void mCopyOn()
{
	copyFunction = mId ;
	copyMode = ON;
}


/****************************
 * mCopyOff                 *
 ****************************/


void    mCopyOff()
{
	copyMode = OFF;
}

/****************************
 * mOn                      *
 ****************************/

void mOn()
{
	copyMode = ON;
}


/****************************
 * mOff                     *
 ****************************/


void    mOff()
{
	copyMode = 0;
}


/****************************
 * mNop                     *
 ****************************/

void mNop()
{
}

/****************************
 * mStop                     *
 ****************************/

void mStop()
{
	stopFlag = 1;
}

/****************************
 * mError                   *
 ****************************/

void mError()
{
	fprintf(stderr, "\nERROR: mError called !!! \n");
	printDebugInformation(0);
}

/****************************
 * mResult                  *
 ****************************/

unsigned long int mResult()
{
	return resultReg;
}

/****************************
 * mLoadPrgReg              *
 ****************************/

void mLoadPrgReg(unsigned long int prg)
{
	prgReg = prg;
	remainingPrgNibbles = 8 ;
}

/* ==================== END of machine dependend function END ================================= */

/****************************
 * setOpsDebug(int level)   *
 ****************************/

void setOpsDebug(int level)
{
	debugOn = level ;
	if (debugOn > 0)
		printf("setOpsDebug: machine debug mode set to level : %d", 
		       level);

}



/****************************
 * getNextInstruction       *
 ****************************/
/* the first 4 bits of reg are returned and reg is shifted right for
   these 4 bits */

unsigned long int	getNextInstruction()
{
	unsigned long int	result = GET_NEXT_INST_DEFAULT;

	if (remainingPrgNibbles > 0)
	{	result = prgReg & 0x0000000f;
		prgReg >>= 4 ;
		remainingPrgNibbles--;
	}
	return result;
}

/****************************
 * callMicroCode            *
 ****************************/

void	callMicroCode(unsigned long int aktInstruction)
{
	MicroCode		microCode;
	unsigned long int	par1;
	int			arrity;
	int			type;

	microCode	= instructionTable[aktInstruction].microCode;
	arrity		= instructionTable[aktInstruction].arrity;
	type		= instructionTable[aktInstruction].type;

	switch(type)	
	{
		case T_LOGIC:
		case T_ARITH:
			if (setCpyFunByArithOp)
				copyFunction = microCode;
			break;
		default:
			break;
			/* don't matter */
	}

	switch (arrity)
	{
		case 0:
			microCode();	/* call microCode    */
			break;
		case 1:
			par1 = getNextInstruction();
			((MicroCode1)microCode)(par1);	 /* cast, sonst type conflict in C++, in C ist cast nicht noetig*/
			break;
		default:
			fprintf(stderr, "WARNING (callMicroCode: unkown arrity %d\n", arrity); 
	}

	switch(type)
	{
		case T_LOGIC:
		case T_ARITH:
			if (movAfterArith)
			{
				mMovOneStep();	
			}
			break;
		default: ;
			/* don't matter */
	}

}


/**************************
 * run(prg, op) -> result *
 **************************/

unsigned long int run(unsigned long int objCode, unsigned long int operand)
{
	return runN(objCode, operand, 1);
}

/****************************
 * correctResult()          *
 ****************************/

/* rotates resultReg according to resultPtPos */

void correctResult()
{	
	int i;
	while(resultPtPos >= 32)
		resultPtPos-=32;
	while(resultPtPos < 0 )
		resultPtPos+=32;
	for( i = resultPtPos ; i > 0 ; i--)
		mMovResPtRight();
	
}


/************************************
* doBindingPref1(unsigned long int) *
*************************************/

/* moves the Result-Pt. left according to the objCode */

void doBindingPref1(unsigned long int objCode)
{
	unsigned long int times = 0;
	int i;

	for(i=0;i<6;i++)
	{
		times	^=	objCode & 0x1f ;
		objCode	>>=	5 ;
	}

	/* move Result-Pt. according to times left */


	for(i=0;i<times;i++)
		mMovResPtRight();
		/* ACHTUNG: resPtPos wird decrementiert */
}


	
		 
/**********************************
* doBindingPref(unsigned lon int) *
***********************************/

void doBindingPref(unsigned long int objCode)
{
	switch(myBindingPref)
	{	case 0: 
			break;
		case 1:
			doBindingPref1(objCode);
			break;
		default:
			fprintf(stderr,  "WARNING: unknown myBindingPref %d !\n", myBindingPref);
	}
}

/*********************************
 * runN(prg, op, rate) -> result *
 *********************************/

unsigned long int runN(unsigned long int objCode, unsigned long int operand, int rate)
{
	unsigned long int	aktInstruction, result ;


	#ifdef DEBUG
	if (debugOn)
		fprintf(stderr, "runN  with %08x %08x %d\n", objCode, operand, rate);
	#endif

	setResultDefault(operand);
	mInit(objCode);		/* move operand to operand register and init the machine */
	mLoadPrgReg(objCode);

	doBindingPref(objCode);

	while(rate > 0)
	{
		while((remainingPrgNibbles > 0) && (stopFlag == 0))
		{
			aktInstruction = getNextInstruction(); 

			#ifdef DEBUG
			if (debugOn > 0)
				printDebugInformation(aktInstruction);
			#endif
			
			callMicroCode(aktInstruction);
		}
		rate--;
		mLoadPrgReg(objCode) ;		/* relode prgReg with objCode (normaly done my mInit) */
	}

	if (! noCorrectionI) 
		correctResult();	/* according to resultPtPos */
	result = mResult();

	#ifdef DEBUG
	if (debugOn)
		fprintf(stderr, "runN result: %08x \n", result);

	#endif
	return result;

}

		
		

/*******************************
 * disAss(objCode) -> string  *
 *******************************/	

char *disAss(unsigned long int objCode)
{
	int i;
	unsigned int aktInstruction;
	static char prgCode[1000];

	prgCode[0] = (char)0;

	for (i=0; i < MAX_INSTRUCTIONS; i++)   /* 8 */
	{
		aktInstruction = 0x0000000f & objCode;
		strcat(prgCode, instructionTable[aktInstruction].opCode);
		if (instructionTable[aktInstruction].arrity == 1)
		{
			objCode >>= INSTRUCTION_LENGTH;
			i++;
			aktInstruction = 0x0000000f & objCode;
			strcat(prgCode, "    " );
			strcat(prgCode, strdup(ulToBin(aktInstruction, 4)) );
		}
		strcat(prgCode, "\n" );
		objCode >>= INSTRUCTION_LENGTH;
	}
	return prgCode;
}




/****************************
 * printDebugInformation    *
 ****************************

INPUT     : instructionNo	no. of instruction to be executed next
SIDEINPUT : machine register
OUTPUT	  : -
SIDEEFFEKT: prints register & instruction inf. to stdout	
--------------------------------------------------------------------------*/

void printBin(unsigned long int data, int length)
{
	fprintBin(stdout, data, length);
}


void fprintBin(FILE *fh, unsigned long int data, int length)
{
	unsigned long int mask;

	mask = (unsigned long int) 1 << (length - 1);

	while (length > 0)
	{
		if ((data & mask) >= 1)
			fprintf(fh, "1");
		else
			fprintf(fh, "0");
		data <<= 1;
		length--;
	}
}


char *ulToBin(unsigned long int data, int length)
{
	unsigned long int mask;
	static char hh[40];
	int	p;
	p = 0;

	mask = (unsigned long int) 1 << (length - 1);

	while (length > 0)
	{
		if ((data & mask) >= 1)
			hh[p++]=(char)'1';
		else
			hh[p++]=(char)'0';
		data <<= 1;
		length--;
	}
	hh[p]=(char)0;
	return hh;
}


void	printDebugInformation(int instructionNo)
{
	printf("    OpReg: ");
	printBin(opReg, 32);
	printf("   resultReg : ");
	printBin(resultReg, 32);
	if (patternSet)
	{
		printf("   Pattern set to : ");
		printBin(patternReg, 2);
	}

	printf("\n");
	printBin(instructionNo, 4);
	printf("    %s\n", instructionTable[instructionNo].opCode);
}

/* ================================================================================= */
/*		ASSEMBLER							     */
/* ================================================================================= */

/* ass. def. */

#define FROM_FILE = 1
#define FROM_STRING = 2;

/* ass. state-vars */

FILE	*inputFH;
char	*inputString;
int	inputMode;		/* (FROM_FILE, FROM_STRING) */


/* the multi-language-komplex-hi-tech-surround-chomsky-parser with
   a generic computaional comment extension : */

char *getNextToken(FILE *fh)
{
	static char nextToken[300];	/* bad style !!! */

	nextToken[0]= (char)0;
	fscanf(fh,"%s", nextToken);
	while (nextToken[0] == (char)';') 	/* skip comments (max. ca. 250 chars per line) */
	{
		nextToken[0]=(char)0;
		fgets(nextToken, 300, fh);
		fscanf(fh,"%s", nextToken);
	}
	return nextToken;
}

/****************************
 * ass                      *
 ****************************/

 
unsigned long int       ass(char *srcCode)
{
	unsigned long int	result;
	FILE *fh;

	if ((fh = (FILE *)0 /* string2Stream(srcCode) */) == (FILE *)0 )
	{
		fprintf(stderr, "ERROR(ass): can't string2Stream srcCode>%20s ...< \n.", srcCode);
		exit(1);
	}

	result = assFromFH(fh);
	fclose(fh);
	return result;


}


/****************************
 * assFromFile              *
 ****************************/

unsigned long int       assFromFile(char *srcFileName)
{
	FILE			*fh;
	unsigned long int	result;

	if ((fh = fopen(srcFileName,"r")) == (FILE *)NULL )
	{
		fprintf(stderr, "ERROR(assFromFile): can't open >%s< \n.", srcFileName);
		exit(1);
	}
	result = assFromFH(fh);
	fclose(fh);
	return result;
}
	

/****************************
 * decodeToken              *
 ****************************/
#define SYMB_TABLE_LAST_ENTRY {"", 999}
#define SYMB_TABLE_END(st) (st.code == 999)

unsigned long int decodeToken(char *token)
{
	int i;
	unsigned long int result;

	struct { char *token; unsigned long int code;} symbTable[] =
	{	{"0000", 0},
		{"0001", 1},
		{"0010", 2},
		{"0011", 3},
		{"0100", 4},
		{"0101", 5},
		{"0110", 6},
		{"0111", 7},
		{"1000", 8},
		{"1001", 9},
		{"1010",10},
		{"1011",11},
		{"1100",12},
		{"1101",13},
		{"0110",14},
		{"1111",15},
		SYMB_TABLE_LAST_ENTRY
	};
	if (debugOn)
		printf("decoding TOKEN: >%s<\n", token);

	result = NOT_FOUND;
	for(i=0;(! SYMB_TABLE_END(symbTable[i])) && (result == NOT_FOUND); i++)
		if (strcmp(symbTable[i].token, token) == 0)
			result = symbTable[i].code;   /* token found */
	for(i=0;(i<16) && (result == NOT_FOUND);i++)
		if (strcmp(instructionTable[i].opCode, token) == 0)
			result = i;   /* token found */

	return result;
}

	
/**************************
 * assFromFH              *
 **************************/

unsigned long int       assFromFH(FILE *fh)
{
	char			*nextToken;
	unsigned long int	code;
	unsigned long int	result = 0x00000000;
	int			prgLength = 0;		/* in nibbles */

	while(!feof(fh))
	{
		nextToken = getNextToken(fh);	/* get next token */
		if (nextToken[0] != (char)0)
		{
			code = decodeToken(nextToken);	/* get binary code of the token */

			if (prgLength >= 8)
			{
				fprintf(stderr, "WARNING (assFromFH): programm length (8) exeeded (truncated). \n");
			} 
			else if (code == NOT_FOUND)
				fprintf(stderr, "WARNING (assFromFH): token not found: >%s<\n", nextToken);
			else
			{
				result >>= 4;			/* append code to result */
				code <<= 28 ;
				result |= code;
				prgLength++;
			}
		}
	}
	/* shift prg to start */
	while(prgLength < 8)
	{
		result>>=4;
		result |= ((unsigned long int)DEFAULT_CODE << 28);
		prgLength ++;
	}
	return result;
}

/****************************
 * printAss                 *
 ****************************/

void printAss()
{
	fprintAss(stdout);
}


/****************************
 * fprintAss                 *
 ****************************/

void	fprintAss(FILE *fh)
{
	int i;
	fprintf(fh, "\n\n");
	for (i=0; i<16;i++)
	{	
		fprintf(fh, "(%2d)  ", i);
		fprintBin(fh, (unsigned long int)i, 4);
		fprintf(fh,  " %s\n",instructionTable[i].opCode);
	}
}

